*** ../tcl7.0b1/./tcl.h	Wed Jul  7 16:24:42 1993
--- ./tcl.h	Mon Jul 19 16:07:29 1993
***************
*** 24,30 ****
   * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
   * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
   *
!  * $Header: /user6/ouster/tcl/RCS/tcl.h,v 1.116 93/07/07 16:24:40 ouster Exp $ SPRITE (Berkeley)
   */
  
  #ifndef _TCL
--- 24,30 ----
   * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
   * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
   *
!  * $Header: /user6/ouster/tcl/RCS/tcl.h,v 1.117 93/07/19 08:47:25 ouster Exp $ SPRITE (Berkeley)
   */
  
  #ifndef _TCL
***************
*** 88,94 ****
  #endif
  
  #ifndef _CLIENTDATA
! typedef int *ClientData;
  #define _CLIENTDATA
  #endif
  
--- 88,98 ----
  #endif
  
  #ifndef _CLIENTDATA
! #   ifdef __STDC__
!     typedef void *ClientData;
! #   else
!     typedef int *ClientData;
! #   endif /* __STDC__ */
  #define _CLIENTDATA
  #endif
  
*** ../tcl7.0b1/./tclUnix.h	Thu Jul  8 09:59:27 1993
--- ./tclUnix.h	Mon Jul 19 16:08:14 1993
***************
*** 31,37 ****
   * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
   * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
   *
!  * $Header: /user6/ouster/tcl/RCS/tclUnix.h,v 1.41 93/07/08 09:59:26 ouster Exp $ SPRITE (Berkeley)
   */
  
  #ifndef _TCLUNIX
--- 31,37 ----
   * ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
   * PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
   *
!  * $Header: /user6/ouster/tcl/RCS/tclUnix.h,v 1.43 93/07/19 16:08:04 ouster Exp $ SPRITE (Berkeley)
   */
  
  #ifndef _TCLUNIX
***************
*** 62,71 ****
  #ifndef NO_SYS_WAIT_H
  #   include <sys/wait.h>
  #endif
! #ifndef HAVE_UNISTD
  #   include <unistd.h>
  #else
! #   include <compat/unistd.h>
  #endif
  
  /*
--- 62,71 ----
  #ifndef NO_SYS_WAIT_H
  #   include <sys/wait.h>
  #endif
! #ifdef HAVE_UNISTD_H
  #   include <unistd.h>
  #else
! #   include "compat/unistd.h"
  #endif
  
  /*
*** ../tcl7.0b1/./configure.in	Thu Jun  3 15:39:17 1993
--- ./configure.in	Mon Jul 19 15:21:41 1993
***************
*** 1,15 ****
  dnl	This file is an input file used by the GNU "autoconf" program to
  dnl	generate the file "configure", which is run during Tcl installation
  dnl	to configure the system for the local environment.
- 
  AC_INIT(tcl.h)
  AC_PROG_INSTALL
  AC_PROG_RANLIB
  
! dnl--------------------------------------------------------------------
! dnl	Supply substitutes for missing POSIX library procedures, or set
! dnl	flags so Tcl uses alternate procedures.
! dnl--------------------------------------------------------------------
  
  AC_REPLACE_FUNCS(getcwd opendir strerror strstr strtod)
  AC_REPLACE_FUNCS(strtol strtoul tmpnam waitpid)
--- 1,14 ----
  dnl	This file is an input file used by the GNU "autoconf" program to
  dnl	generate the file "configure", which is run during Tcl installation
  dnl	to configure the system for the local environment.
  AC_INIT(tcl.h)
  AC_PROG_INSTALL
  AC_PROG_RANLIB
  
! #--------------------------------------------------------------------
! #	Supply substitutes for missing POSIX library procedures, or
! #	set flags so Tcl uses alternate procedures.
! #--------------------------------------------------------------------
  
  AC_REPLACE_FUNCS(getcwd opendir strerror strstr strtod)
  AC_REPLACE_FUNCS(strtol strtoul tmpnam waitpid)
***************
*** 17,32 ****
  AC_FUNC_CHECK(getwd, , AC_DEFINE(NO_GETWD))
  AC_FUNC_CHECK(wait3, , AC_DEFINE(NO_WAIT3))
  
! 
! dnl--------------------------------------------------------------------
! dnl	Supply substitutes for missing POSIX header files.  Special
! dnl	notes:
! dnl	    - Sprite's dirent.h exists but is bogus.
! dnl	    - stdlib.h doesn't define strtol, strtoul, or
! dnl	      strtod insome versions of SunOS
! dnl	    - some versions of string.h don't declare procedures such
! dnl	      as strstr
! dnl--------------------------------------------------------------------
  
  AC_UNISTD_H
  AC_COMPILE_CHECK(dirent.h, [#include <sys/types.h>
--- 16,30 ----
  AC_FUNC_CHECK(getwd, , AC_DEFINE(NO_GETWD))
  AC_FUNC_CHECK(wait3, , AC_DEFINE(NO_WAIT3))
  
! #--------------------------------------------------------------------
! #	Supply substitutes for missing POSIX header files.  Special
! #	notes:
! #	    - Sprite's dirent.h exists but is bogus.
! #	    - stdlib.h doesn't define strtol, strtoul, or
! #	      strtod insome versions of SunOS
! #	    - some versions of string.h don't declare procedures such
! #	      as strstr
! #--------------------------------------------------------------------
  
  AC_UNISTD_H
  AC_COMPILE_CHECK(dirent.h, [#include <sys/types.h>
***************
*** 38,61 ****
  entryPtr = readdir(d);
  p = entryPtr->d_name;
  closedir(d);
! ], , AC_DEFINE(NO_DIRENT_H))
! AC_HEADER_EGREP([Sprite version.* NOT POSIX], AC_DEFINE(NO_DIRENT_H))
  AC_HEADER_CHECK(float.h, , AC_DEFINE(NO_FLOAT_H))
  AC_HEADER_CHECK(limits.h, , AC_DEFINE(NO_LIMITS_H))
! AC_HEADER_CHECK(stdlib.h, , AC_DEFINE(NO_STDLIB_H))
! AC_HEADER_EGREP(strtol, stdlib.h, , AC_DEFINE(NO_STDLIB_H))
! AC_HEADER_EGREP(strtoul, stdlib.h, , AC_DEFINE(NO_STDLIB_H))
! AC_HEADER_EGREP(strtod, stdlib.h, , AC_DEFINE(NO_STDLIB_H))
! AC_HEADER_CHECK(string.h, , AC_DEFINE(NO_STRING_H))
! AC_HEADER_EGREP(strstr, string.h, , AC_DEFINE(NO_STRING_H))
! AC_HEADER_EGREP(strerror, string.h, , AC_DEFINE(NO_STRING_H))
  AC_HEADER_CHECK(sys/time.h, , AC_DEFINE(NO_SYS_TIME_H))
  AC_HEADER_CHECK(sys/wait.h, , AC_DEFINE(NO_SYS_WAIT_H))
  
! dnl--------------------------------------------------------------------
! dnl	On some systems strstr is broken: it returns a pointer even
! dnl	even if the original string is empty.
! dnl--------------------------------------------------------------------
  
  AC_TEST_PROGRAM([
  extern int strstr();
--- 36,62 ----
  entryPtr = readdir(d);
  p = entryPtr->d_name;
  closedir(d);
! ], tcl_ok=1, tcl_ok=0)
! AC_HEADER_EGREP([Sprite version.* NOT POSIX], tcl_ok=0)
! if test $tcl_ok = 0; then AC_DEFINE(NO_DIRENT_H); fi
  AC_HEADER_CHECK(float.h, , AC_DEFINE(NO_FLOAT_H))
  AC_HEADER_CHECK(limits.h, , AC_DEFINE(NO_LIMITS_H))
! AC_HEADER_CHECK(stdlib.h, tcl_ok=1, tcl_ok=0)
! AC_HEADER_EGREP(strtol, stdlib.h, , tcl_ok=0)
! AC_HEADER_EGREP(strtoul, stdlib.h, , tcl_ok=0)
! AC_HEADER_EGREP(strtod, stdlib.h, , tcl_ok=0)
! if test $tcl_ok = 0; then AC_DEFINE(NO_STDLIB_H); fi
! AC_HEADER_CHECK(string.h, tcl_ok=1, tcl_ok=0)
! AC_HEADER_EGREP(strstr, string.h, , tcl_ok=0)
! AC_HEADER_EGREP(strerror, string.h, , tcl_ok=0)
! if test $tcl_ok = 0; then AC_DEFINE(NO_STRING_H); fi
  AC_HEADER_CHECK(sys/time.h, , AC_DEFINE(NO_SYS_TIME_H))
  AC_HEADER_CHECK(sys/wait.h, , AC_DEFINE(NO_SYS_WAIT_H))
  
! #--------------------------------------------------------------------
! #	On some systems strstr is broken: it returns a pointer even
! #	even if the original string is empty.
! #--------------------------------------------------------------------
  
  AC_TEST_PROGRAM([
  extern int strstr();
***************
*** 65,74 ****
  }
  ],  , [LIBOBJS="$LIBOBJS strstr.o"])
  
! dnl--------------------------------------------------------------------
! dnl	Under some versions of AIX strtoul returns an incorrect terminator
! dnl	pointer for the string "0".
! dnl--------------------------------------------------------------------
  
  AC_TEST_PROGRAM([
  extern int strtoul();
--- 66,75 ----
  }
  ],  , [LIBOBJS="$LIBOBJS strstr.o"])
  
! #--------------------------------------------------------------------
! #	Under some versions of AIX strtoul returns an incorrect terminator
! #	pointer for the string "0".
! #--------------------------------------------------------------------
  
  AC_TEST_PROGRAM([
  extern int strtoul();
***************
*** 84,110 ****
      exit(0);
  }], , [LIBOBJS="$LIBOBJS strtoul.o"])
  
! dnl--------------------------------------------------------------------
! dnl	Check for missing pid_t and uid_t typedefs.
! dnl--------------------------------------------------------------------
  
  AC_PID_T
  AC_UID_T
  
! dnl--------------------------------------------------------------------
! dnl	If a system doesn't have an opendir function (man, that's old!)
! dnl	then we have to supply a different version of dirent.h which
! dnl	is compatible with the substitute version of opendir that's
! dnl	provided.  This version only works with V7-style directories.
! dnl--------------------------------------------------------------------
  
  AC_FUNC_CHECK(opendir, , AC_DEFINE(USE_DIRENT2_H))
  
! dnl--------------------------------------------------------------------
! dnl	Check for the existence of sys_errlist (this is only needed if
! dnl	there's no strerror, but I don't know how to conditionalize the
! dnl	check).
! dnl--------------------------------------------------------------------
  
  AC_COMPILE_CHECK(sys_errlist, , [
  extern char *sys_errlist[];
--- 85,114 ----
      exit(0);
  }], , [LIBOBJS="$LIBOBJS strtoul.o"])
  
! #--------------------------------------------------------------------
! #	Check for various typedefs and provide substitutes if
! #	they don't exist.
! #--------------------------------------------------------------------
  
+ AC_MODE_T
  AC_PID_T
+ AC_SIZE_T
  AC_UID_T
  
! #--------------------------------------------------------------------
! #	If a system doesn't have an opendir function (man, that's old!)
! #	then we have to supply a different version of dirent.h which
! #	is compatible with the substitute version of opendir that's
! #	provided.  This version only works with V7-style directories.
! #--------------------------------------------------------------------
  
  AC_FUNC_CHECK(opendir, , AC_DEFINE(USE_DIRENT2_H))
  
! #--------------------------------------------------------------------
! #	Check for the existence of sys_errlist (this is only needed if
! #	there's no strerror, but I don't know how to conditionalize the
! #	check).
! #--------------------------------------------------------------------
  
  AC_COMPILE_CHECK(sys_errlist, , [
  extern char *sys_errlist[];
***************
*** 112,124 ****
  sys_errlist[sys_nerr-1][0] = 0;
  ], , AC_DEFINE(NO_SYS_ERRLIST))
  
! dnl--------------------------------------------------------------------
! dnl	The check below checks whether <sys/wait.h> defines the type
! dnl	"union wait" correctly.  It's needed because of weirdness in
! dnl	HP-UX where "union wait" is defined in both the BSD and SYS-V
! dnl	environments.  Checking the usability of WIFEXITED seems to do
! dnl	the trick.
! dnl--------------------------------------------------------------------
  
  AC_COMPILE_CHECK([union wait], [#include <sys/types.h> 
  #include <sys/wait.h>], [
--- 116,128 ----
  sys_errlist[sys_nerr-1][0] = 0;
  ], , AC_DEFINE(NO_SYS_ERRLIST))
  
! #--------------------------------------------------------------------
! #	The check below checks whether <sys/wait.h> defines the type
! #	"union wait" correctly.  It's needed because of weirdness in
! #	HP-UX where "union wait" is defined in both the BSD and SYS-V
! #	environments.  Checking the usability of WIFEXITED seems to do
! #	the trick.
! #--------------------------------------------------------------------
  
  AC_COMPILE_CHECK([union wait], [#include <sys/types.h> 
  #include <sys/wait.h>], [
***************
*** 127,146 ****
  			 * uses an int. */
  ], , AC_DEFINE(NO_UNION_WAIT))
  
! dnl--------------------------------------------------------------------
! dnl	The code below cleans up the DEFS variable to eliminate
! dnl	duplicate entries.  This makes the eventual make output
! dnl	look a bit cleaner.
! dnl--------------------------------------------------------------------
! 
! newDefs=""
! for i in $DEFS; do
!     if test -z "$newDefs"; then
!         newDefs=$i
!     elif echo $newDefs | fgrep -v -e $i >/dev/null 2>&1; then
!         newDefs="$newDefs $i"
!     fi
! done
! DEFS=$newDefs
  
  AC_OUTPUT(Makefile)
--- 131,145 ----
  			 * uses an int. */
  ], , AC_DEFINE(NO_UNION_WAIT))
  
! #--------------------------------------------------------------------
! #	Check to see whether the system supports the matherr function
! #	and its associated type "struct exception".
! #--------------------------------------------------------------------
! 
! AC_COMPILE_CHECK([matherr support], [#include <math.h>], [
! struct exception x;
! x.type = DOMAIN;
! x.type = SING;
! ], [LIBOBJS="$LIBOBJS tclMtherr.o"; AC_DEFINE(NEED_MATHERR)])
  
  AC_OUTPUT(Makefile)
*** ../tcl7.0b1/./changes	Wed Jul  7 16:25:16 1993
--- ./changes	Mon Jul 19 15:12:26 1993
***************
*** 793,796 ****
  200. 7/7/93 Added Tcl_SetRecursionLimit procedure so that the maximum
  allowable nesting depth can be controlled for an interpreter from C.
  
! ----------------- Released version 7.0 Beta 1, 6/9/93 ------------------
--- 793,827 ----
  200. 7/7/93 Added Tcl_SetRecursionLimit procedure so that the maximum
  allowable nesting depth can be controlled for an interpreter from C.
  
! ----------------- Released version 7.0 Beta 1, 7/9/93 ------------------
! 
! 201. 7/12/93 Modified Tcl_GetInt and tclExpr.c so that full-precision
! unsigned integers can be specified without overflow errors.
! 
! 202. 7/12/93 Configuration changes:  eliminate leading blank line in
! configure script;  provide separate targets in Makefile for installing
! binary and non-binary information; check for size_t and a few other
! potentially missing typedefs; don't put tclAppInit.o into libtcl.a;
! better checks for matherr support.
! 
! 203. 7/14/93 Changed tclExpr.c to check the termination pointer before
! errno after strtod calls, to avoid problems with some versions of
! strtod that set errno in unexpected ways.
! 
! 204. 7/16/93 Changed "scan" command to be more ANSI-conformant:
! eliminated %F, %D, etc., added code to ignore "l", "h", and "L"
! modifiers but always convert %e, %f, and %g with implicit "l";
! also added support for %u and %i.  Also changed "format" command
! to eliminate %D, %U, %O, and add %i.
! *** POTENTIAL INCOMPATIBILITY ***
! 
! 205. 7/17/93 Changed "uplevel" and "upvar" so that they can be used
! from global level to global level:  this used to generate an error.
! 
! 206. 7/19/93 Renamed "setenv", "putenv", and "unsetenv" procedures
! to avoid conflicts with system procedures with the same names.  If
! you want Tcl's procedures to override the system procedures, do it
! in the Makefile (instructions are in the Makefile).
! *** POTENTIAL INCOMPATIBILITY ***
! 
! ----------------- Released version 7.0 Beta 2, 7/21/93 ------------------
*** ../tcl7.0b1/./README	Fri Jul  9 13:41:00 1993
--- ./README	Mon Jul 19 15:07:14 1993
***************
*** 9,15 ****
  
  This directory contains the sources and documentation for Tcl, an
  embeddable tool command language.  The information here corresponds
! to release 7.0b1, the first beta release of Tcl 7.0.
  
  2. Documentation
  ----------------
--- 9,15 ----
  
  This directory contains the sources and documentation for Tcl, an
  embeddable tool command language.  The information here corresponds
! to release 7.0b2, the first beta release of Tcl 7.0.
  
  2. Documentation
  ----------------
***************
*** 53,62 ****
  	Tcl commands interactively or execute script files.
  
      (c) If the make fails then you'll have to personalize the Makefile
!         for your site.  You may also wish to personalize the Makefile to
! 	modify the install directories, etc.  There are comments at the
! 	beginning of the Makefile that describe the things you might want
! 	to change and how to change them.
  
      (d) Type "make install" to install Tcl binaries and script files in
          standard places.  You'll need write permission on /usr/local to
--- 53,63 ----
  	Tcl commands interactively or execute script files.
  
      (c) If the make fails then you'll have to personalize the Makefile
!         for your site or possibly modify the distribution in other ways.
! 	First check the file "porting.notes" to see if there are hints
! 	for compiling on your system.  If you need to modify Makefile,
! 	there are comments at the beginning of it that describe the things
! 	you might want to change and how to change them.
  
      (d) Type "make install" to install Tcl binaries and script files in
          standard places.  You'll need write permission on /usr/local to
***************
*** 117,127 ****
      the built-ins plus many other things, now contains a terse but
      complete description of the Tcl language syntax.
  
! Here is a list of all of incompatibilities that affect Tcl scripts:
  
      1. There have been several changes to backslash processing:
! 	- Unknown backslash sequences such as "\a" are now replaced with
! 	  the following character (such as "a");  Tcl used to treat the
  	  backslash as an ordinary character in these cases, so both the
  	  backslash and the following character would be passed through.
  	- Backslash-newline now eats up any white space after the newline,
--- 118,128 ----
      the built-ins plus many other things, now contains a terse but
      complete description of the Tcl language syntax.
  
! Here is a list of all incompatibilities that affect Tcl scripts:
  
      1. There have been several changes to backslash processing:
! 	- Unknown backslash sequences such as "\*" are now replaced with
! 	  the following character (such as "*");  Tcl used to treat the
  	  backslash as an ordinary character in these cases, so both the
  	  backslash and the following character would be passed through.
  	- Backslash-newline now eats up any white space after the newline,
***************
*** 157,162 ****
--- 158,167 ----
      6. The keyword "UNIX" in the variable "errorCode" has been changed to
      "POSIX".
  
+     7. The "format" and "scan" commands no longer support capitalized
+     conversion specifiers such as "%D" that aren't supported by ANSI
+     sprintf and sscanf.
+ 
  Here is a list of all of the incompatibilities that affect C code that
  uses the Tcl library procedures.  If you use an ANSI C compiler then
  any potential problems will be detected when you compile your code:  if
***************
*** 186,191 ****
--- 191,200 ----
  
      8. Tcl_UnixError has been renamed to Tcl_PosixError.
  
+     9. Tcl no longer redefines the library procedures "setenv", "putenv",
+     and "unsetenv" by default.  You have to set up special configuration
+     in the Makefile if you want this.
+ 
  Below is a sampler of the most important new features in Tcl 7.0.  Refer
  to the "changes" file for a complete list.
  
***************
*** 229,236 ****
      that can be used to associated a C variable with a Tcl variable and
      keep them in sync.
  
!     10. A new library procedure Tcl_CommandInfo allows you to retrieve
!     the clientData of a command.
  
  6. Tcl newsgroup
  -----------------
--- 238,246 ----
      that can be used to associated a C variable with a Tcl variable and
      keep them in sync.
  
!     10. New library procedures Tcl_SetCommandInfo and Tcl_GetCommandInfo
!     allow you to set and get the clientData and callback procedure for
!     a command.
  
  6. Tcl newsgroup
  -----------------
*** ../tcl7.0b1/./porting.notes	Mon Jun 21 09:27:04 1993
--- ./porting.notes	Tue Jul 13 16:07:35 1993
***************
*** 113,115 ****
--- 113,124 ----
  
  This brings in the typedef for pid_t, which is needed for
  /usr/include/sys/wait.h in tclUnix.h.
+ 
+ ---------------------------------------------
+ DEC Alphas:
+ ---------------------------------------------
+ 
+ 1. There appears to be a compiler/library bug that causes core-dumps
+ unless you compile tclVar.c without optimization (remove the -O compiler
+ switch).  The problem appears to have been fixed in the 1.3-4 version
+ of the compiler.
*** ../tcl7.0b1/./doc/format.n	Mon May  3 17:09:44 1993
--- ./doc/format.n	Sat Jul 17 15:39:12 1993
***************
*** 18,24 ****
  '\" ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
  '\" PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
  '\" 
! '\" $Header: /user6/ouster/tcl/man/RCS/format.n,v 1.1 93/05/03 17:09:44 ouster Exp $ SPRITE (Berkeley)
  '\" 
  .so man.macros
  .HS format tcl
--- 18,24 ----
  '\" ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
  '\" PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
  '\" 
! '\" $Header: /user6/ouster/tcl/man/RCS/format.n,v 1.2 93/07/17 15:39:01 ouster Exp $ SPRITE (Berkeley)
  '\" 
  .so man.macros
  .HS format tcl
***************
*** 33,56 ****
  .SH DESCRIPTION
  .PP
  This command generates a formatted string in the same way as the
! C \fBsprintf\fR procedure (it uses \fBsprintf\fR in its
! implementation).  \fIFormatString\fR indicates how to format
! the result, using \fB%\fR fields as in \fBsprintf\fR, and the additional
  arguments, if any, provide values to be substituted into the result.
! All of the \fBsprintf\fR options are valid; see the \fBsprintf\fR
! man page for details.
  .VS
  The \fBformat\fR command also supports the XPG3 ``%n$'' positional
  specifiers.
  .VE
- Each \fIarg\fR must match the expected type
- from the \fB%\fR field in \fIformatString\fR; the \fBformat\fR command
- converts each argument to the correct type (floating, integer, etc.)
- before passing it to \fBsprintf\fR for formatting.
- The only unusual conversion is for \fB%c\fR; in this case the argument
- must be a decimal string, which will then be converted to the corresponding
- ASCII character value.
- The return value from \fBformat\fR is the formatted string.
  
  .SH KEYWORDS
  format, sprintf, string, substitution
--- 33,72 ----
  .SH DESCRIPTION
  .PP
  This command generates a formatted string in the same way as the
! ANSI C \fBsprintf\fR procedure (it uses \fBsprintf\fR in its
! implementation).
! \fIFormatString\fR indicates how to format the result, using
! \fB%\fR conversion specifiers as in \fBsprintf\fR, and the additional
  arguments, if any, provide values to be substituted into the result.
! Each \fIarg\fR must match the expected type
! from the corresponding conversion specifier in \fIformatString\fR;
! the \fBformat\fR command converts each argument to the correct
! type (floating, integer, etc.) before passing it to \fBsprintf\fR
! for formatting.
! The return value from \fBformat\fR is the formatted string.
! .PP
! .VS
! The conversion specifiers for \fBformat\fR are identical in syntax
! and effect to those for \fBsprintf\fR except for the following
! differences:
! .IP [1]
! \fB%p\fR and \fB%n\fR specifiers are not currently supported.
! .VE
! .IP [2]
! For \fB%c\fR conmversions the argument must be a decimal string,
! which will then be converted to the corresponding ASCII character value.
! .IP [3]
  .VS
+ The \fBl\fR modifier is ignored;  integer values are always converted
+ as if there were no modifier present and real values are always
+ converted as if the \fBl\fR modifier were present (i.e. type
+ \fBdouble\fR is used for the internal representation).
+ If the \fBh\fR modifier is specified then integer values are truncated
+ to \fBshort\fR before conversion.
+ .PP
  The \fBformat\fR command also supports the XPG3 ``%n$'' positional
  specifiers.
  .VE
  
  .SH KEYWORDS
  format, sprintf, string, substitution
*** ../tcl7.0b1/./doc/return.n	Wed Jul  7 16:37:49 1993
--- ./doc/return.n	Fri Jul 16 16:31:18 1993
***************
*** 18,24 ****
  '\" ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
  '\" PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
  '\" 
! '\" $Header: /user6/ouster/tcl/man/RCS/return.n,v 1.4 93/07/07 16:37:43 ouster Exp $ SPRITE (Berkeley)
  '\" 
  .so man.macros
  .HS return tcl 7.0
--- 18,24 ----
  '\" ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
  '\" PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
  '\" 
! '\" $Header: /user6/ouster/tcl/man/RCS/return.n,v 1.5 93/07/16 16:31:07 ouster Exp $ SPRITE (Berkeley)
  '\" 
  .so man.macros
  .HS return tcl 7.0
***************
*** 27,33 ****
  .SH NAME
  return \- Return from a procedure
  .SH SYNOPSIS
! \fBreturn \fR?\fIvalue\fR? ?\fIcode\fR?
  .BE
  
  .SH DESCRIPTION
--- 27,33 ----
  .SH NAME
  return \- Return from a procedure
  .SH SYNOPSIS
! \fBreturn \fR?\fB\-code \fIcode\fR? ?\fIstring\fR?
  .BE
  
  .SH DESCRIPTION
***************
*** 34,52 ****
  .PP
  Return immediately from the current procedure
  (or top-level command or \fBsource\fR command),
! with \fIvalue\fR as the return value.  If \fIvalue\fR is not specified then
  an empty string will be returned as result.
  .PP
! In the normal case where \fIcode\fR isn't specified the procedure
  .VS
! will return normally (its completion code will be TCL_OK).
! However, \fIcode\fR may be used to cause the procedure to return
! with an exceptional completion code, which will generate an exception
! in the script that invoked the current procedure.
  \fICode\fR may have any of the following values:
  .TP 10
  \fBok\fR
! Normal return:  same as if \fIcode\fR were omitted.
  .TP 10
  \fBerror\fR
  Error return: same as if the \fBerror\fR command were used to
--- 34,53 ----
  .PP
  Return immediately from the current procedure
  (or top-level command or \fBsource\fR command),
! with \fIstring\fR as the return value.  If \fIstring\fR is not specified then
  an empty string will be returned as result.
  .PP
! In the usual case where the \fB\-code\fR option isn't
  .VS
! specified the procedure will return normally (its completion
! code will be TCL_OK).
! However, the \fB\-code\fR option may be used to cause the
! procedure to return with an exceptional completion code,
! which will generate an exception in the script that invoked the procedure.
  \fICode\fR may have any of the following values:
  .TP 10
  \fBok\fR
! Normal return:  same as if the option is omitted.
  .TP 10
  \fBerror\fR
  Error return: same as if the \fBerror\fR command were used to
***************
*** 72,78 ****
  \fIValue\fR must be an integer;  it will be returned as the
  completion code for the current procedure.
  .LP
! \fICode\fR is rarely used.
  It is provided so that procedures that implement
  new control structures can reflect exceptional conditions back to
  their callers.
--- 73,79 ----
  \fIValue\fR must be an integer;  it will be returned as the
  completion code for the current procedure.
  .LP
! The \fB\-code\fR option is rarely used.
  It is provided so that procedures that implement
  new control structures can reflect exceptional conditions back to
  their callers.
*** ../tcl7.0b1/./doc/scan.n	Mon Jun  7 16:48:27 1993
--- ./doc/scan.n	Fri Jul 16 16:56:14 1993
***************
*** 18,24 ****
  '\" ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
  '\" PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
  '\" 
! '\" $Header: /user6/ouster/tcl/man/RCS/scan.n,v 1.1 93/06/07 16:48:26 ouster Exp $ SPRITE (Berkeley)
  '\" 
  .so man.macros
  .HS scan tcl
--- 18,24 ----
  '\" ON AN "AS IS" BASIS, AND THE UNIVERSITY OF CALIFORNIA HAS NO OBLIGATION TO
  '\" PROVIDE MAINTENANCE, SUPPORT, UPDATES, ENHANCEMENTS, OR MODIFICATIONS.
  '\" 
! '\" $Header: /user6/ouster/tcl/man/RCS/scan.n,v 1.2 93/07/16 16:55:51 ouster Exp $ SPRITE (Berkeley)
  '\" 
  .so man.macros
  .HS scan tcl
***************
*** 33,50 ****
  .SH DESCRIPTION
  .PP
  This command parses fields from an input string in the same fashion
! as the C \fBsscanf\fR procedure and returns a count of the number
  of fields sucessfully parsed.  \fIString\fR gives the input to
  be parsed and \fIformat\fR indicates how to parse it, using \fB%\fR
! fields as in \fBsscanf\fR.  All of the \fBsscanf\fR options are valid;
! see the \fBsscanf\fR man page for details.  Each \fIvarName\fR gives
  the name of a variable; when a field is scanned from \fIstring\fR,
  the result is converted back into a string and assigned to the
! corresponding \fIvarName\fR.  The only unusual conversion is for
! \fB%c\fR.  For \fB%c\fR conversions a single character value is
  converted to a decimal string, which is then assigned to the
  corresponding \fIvarName\fR;
  no field width may be specified for this conversion.
  
  .SH KEYWORDS
  parse, scan
--- 33,65 ----
  .SH DESCRIPTION
  .PP
  This command parses fields from an input string in the same fashion
! as the ANSI C \fBsscanf\fR procedure and returns a count of the number
  of fields sucessfully parsed.  \fIString\fR gives the input to
  be parsed and \fIformat\fR indicates how to parse it, using \fB%\fR
! fields as in \fBsscanf\fR.  Each \fIvarName\fR gives
  the name of a variable; when a field is scanned from \fIstring\fR,
  the result is converted back into a string and assigned to the
! corresponding \fIvarName\fR. 
! All of the \fBsscanf\fR conversion specifiers are valid except for
! the following differences:
! .IP [1]
! .VS
! \fB%p\fR and \fB%n\fR conversion specifiers are not currently
! supported.
! .VE
! .IP [2]
! For \fB%c\fR conversions a single character value is
  converted to a decimal string, which is then assigned to the
  corresponding \fIvarName\fR;
  no field width may be specified for this conversion.
+ .IP [3]
+ .VS
+ The \fBl\fR, \fBh\fR, and \fBL\fR modifiers are ignored;  integer
+ values are always converted as if there were no modifier present
+ and real values are always converted as if the \fBl\fR modifier
+ were present (i.e. type \fBdouble\fR is used for the internal
+ representation).
+ .VE
  
  .SH KEYWORDS
  parse, scan
*** ../tcl7.0b1/./compat/getcwd.c	Thu Jun  3 15:08:50 1993
--- ./compat/getcwd.c	Mon Jul 12 14:01:03 1993
***************
*** 26,33 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/compat/RCS/strtod.c,v 1.4 93/0
! 3/19 15:25:47 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  #include "tclInt.h"
--- 26,32 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/compat/RCS/getcwd.c,v 1.2 93/07/12 14:00:59 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  #include "tclInt.h"
*** ../tcl7.0b1/./compat/strtod.c	Fri Mar 19 15:25:49 1993
--- ./compat/strtod.c	Mon Jul 12 14:01:20 1993
***************
*** 25,35 ****
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/compat/RCS/strtod.c,v 1.4 93/03/19 15:25:47 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  #include <tcl.h>
! #include <stdlib.h>
  #include <ctype.h>
  
  #ifndef TRUE
--- 25,39 ----
   */
  
  #ifndef lint
! static char rcsid[] = "$Header: /user6/ouster/tcl/compat/RCS/strtod.c,v 1.5 93/07/12 14:01:07 ouster Exp $ SPRITE (Berkeley)";
  #endif /* not lint */
  
  #include <tcl.h>
! #ifdef NO_STDLIB_H
! #   include "compat/stdlib.h"
! #else
! #   include <stdlib.h>
! #endif
  #include <ctype.h>
  
  #ifndef TRUE
